summaryrefslogtreecommitdiffstats
path: root/network/GlobalProtect-openconnect
diff options
context:
space:
mode:
Diffstat (limited to 'network/GlobalProtect-openconnect')
-rw-r--r--network/GlobalProtect-openconnect/GlobalProtect-openconnect.SlackBuild112
-rw-r--r--network/GlobalProtect-openconnect/GlobalProtect-openconnect.info10
-rw-r--r--network/GlobalProtect-openconnect/README13
-rw-r--r--network/GlobalProtect-openconnect/doinst.sh28
-rw-r--r--network/GlobalProtect-openconnect/rc.gpservice36
-rw-r--r--network/GlobalProtect-openconnect/slack-desc19
6 files changed, 218 insertions, 0 deletions
diff --git a/network/GlobalProtect-openconnect/GlobalProtect-openconnect.SlackBuild b/network/GlobalProtect-openconnect/GlobalProtect-openconnect.SlackBuild
new file mode 100644
index 0000000000..1a38375750
--- /dev/null
+++ b/network/GlobalProtect-openconnect/GlobalProtect-openconnect.SlackBuild
@@ -0,0 +1,112 @@
+#!/bin/bash
+
+# Slackware build script for GlobalProtect-openconnect
+
+# Copyright 2024 Marek Wodzinski <majek@w7i.pl>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=GlobalProtect-openconnect
+SRCNAM=globalprotect-openconnect
+VERSION=${VERSION:-1.4.9}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cmake -B build \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DCMAKE_CXX_FLAGS_RELEASE=-s
+cmake --build build
+DESTDIR=$PKG cmake --install build
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+install -m755 -D $CWD/rc.gpservice $PKG/etc/rc.d/rc.gpservice.new
+mv $PKG/etc/gpservice/gp.conf $PKG/etc/gpservice/gp.conf.new
+rm -rfv $PKG/usr/lib
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/network/GlobalProtect-openconnect/GlobalProtect-openconnect.info b/network/GlobalProtect-openconnect/GlobalProtect-openconnect.info
new file mode 100644
index 0000000000..4730fe1a43
--- /dev/null
+++ b/network/GlobalProtect-openconnect/GlobalProtect-openconnect.info
@@ -0,0 +1,10 @@
+PRGNAM="GlobalProtect-openconnect"
+VERSION="1.4.9"
+HOMEPAGE="https://github.com/yuezk/GlobalProtect-openconnect/"
+DOWNLOAD="https://github.com/yuezk/GlobalProtect-openconnect/releases/download/v1.4.9/globalprotect-openconnect-1.4.9.tar.gz"
+MD5SUM="85f3d5f718f06291a52e63bba59405a6"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="openconnect"
+MAINTAINER="Marek Wodzinski"
+EMAIL="majek@w7i.pl"
diff --git a/network/GlobalProtect-openconnect/README b/network/GlobalProtect-openconnect/README
new file mode 100644
index 0000000000..562171c0f4
--- /dev/null
+++ b/network/GlobalProtect-openconnect/README
@@ -0,0 +1,13 @@
+A GlobalProtect VPN client (GUI) for Linux based on Openconnect and
+built with Qt5, supports SAML auth mode, inspired by gp-saml-gui.
+
+Features
+- Similar user experience as the official client in macOS.
+- Supports both SAML and non-SAML authentication modes.
+- Supports automatically selecting the preferred gateway from
+ the multiple gateways.
+- Supports switching gateway from the system tray menu manually.
+
+This is two part application:
+- gpservice - daemon, should be started by /etc/rc.d/rc.gpservice
+- gpclient - client GUI application
diff --git a/network/GlobalProtect-openconnect/doinst.sh b/network/GlobalProtect-openconnect/doinst.sh
new file mode 100644
index 0000000000..f4dab04011
--- /dev/null
+++ b/network/GlobalProtect-openconnect/doinst.sh
@@ -0,0 +1,28 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.gpservice.new
+
+# Does the finished package have config files in etc/?
+config etc/gpservice/gp.conf.new
diff --git a/network/GlobalProtect-openconnect/rc.gpservice b/network/GlobalProtect-openconnect/rc.gpservice
new file mode 100644
index 0000000000..c95aebfff4
--- /dev/null
+++ b/network/GlobalProtect-openconnect/rc.gpservice
@@ -0,0 +1,36 @@
+#!/bin/bash
+#
+# Start/stop gpservice
+# Written by Marek Wodzinski <majek@w7i.pl>
+
+# Start gpservice
+gpservice_start() {
+ if [ -x /usr/bin/gpservice ]; then
+ echo "Starting gpservice."
+ /usr/bin/gpservice &
+ fi
+}
+
+# Stop gpservice
+gpservice_stop() {
+ echo "Stopping gpservice."
+ killall gpservice
+}
+
+case "$1" in
+ start)
+ gpservice_start
+ ;;
+ stop)
+ gpservice_stop
+ ;;
+ restart)
+ gpservice_stop
+ sleep 1
+ gpservice_start
+ ;;
+ *)
+ echo "usage @0 start|stop|restart"
+ exit 1
+ ;;
+esac
diff --git a/network/GlobalProtect-openconnect/slack-desc b/network/GlobalProtect-openconnect/slack-desc
new file mode 100644
index 0000000000..f4d7549db6
--- /dev/null
+++ b/network/GlobalProtect-openconnect/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+GlobalProtect-openconnect: GlobalProtect-openconnect (A GlobalProtect VPN client (GUI))
+GlobalProtect-openconnect:
+GlobalProtect-openconnect: A GlobalProtect VPN client (GUI) for Linux based on Openconnect and
+GlobalProtect-openconnect: built with Qt5, supports SAML auth mode, inspired by gp-saml-gui.
+GlobalProtect-openconnect:
+GlobalProtect-openconnect: Features:
+GlobalProtect-openconnect: Similar user experience as the official client in macOS.
+GlobalProtect-openconnect: Supports both SAML and non-SAML authentication modes.
+GlobalProtect-openconnect: Supports automatically selecting the preferred gateway from
+GlobalProtect-openconnect: the multiple gateways.
+GlobalProtect-openconnect: Supports switching gateway from the system tray menu manually.